'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RedirectCode = undefined;
exports.restrictTo = restrictTo;
exports.restrictPath = restrictPath;

var _webError = require('web-error');

var _webError2 = _interopRequireDefault(_webError);

var _RedirectCode = require('../constants/RedirectCode');

var _RedirectCode2 = _interopRequireDefault(_RedirectCode);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.RedirectCode = _RedirectCode2.default;
function restrictTo(domain) {
  var code = arguments.length <= 1 || arguments[1] === undefined ? _RedirectCode2.default.TEMPORARY : arguments[1];

  return function (req, res, next) {
    if (req.hostname === domain) {
      return next();
    }

    var newUrl = req.protocol + '://' + domain + req.originalUrl;
    res.redirect(code, newUrl);
  };
}

function restrictPath(domain, path) {
  return function (req, res, next) {
    if (req.hostname !== domain) {
      return next();
    }

    if (path instanceof RegExp && path.test(req.path)) {
      return next();
    }

    if (path === req.path) {
      return next();
    }

    next(new _webError2.default(404));
  };
}